module ML.IdentifierManipulation where

import qualified Phrac.AbstractSyntax as HS
import Phrac.Pretty
import ML.Identifiers

dirty = ['-', '#', '[', ']']

cleanup [] = []
cleanup (c:cs) | c `elem` dirty = 'x' : cleanup cs
               | otherwise      = c   : cleanup cs

methodId2valId :: HS.ValId -> ValId
methodId2valId x = ValId $ cleanup ("xm_" ++ showPpr x)

classId2valId :: HS.ClassId -> ValId
classId2valId x = ValId $ cleanup ("xC_" ++ showPpr x)

varId2coreId :: HS.ValId -> CoreId
varId2coreId x = CoreId $ cleanup ("cz_" ++ showPpr x)

typVar2typId :: HS.TypeVarId -> TypId
typVar2typId x = TypId $ cleanup ("ta_" ++ showPpr x)

typVar2simTypVar :: HS.TypeVarId -> SimTyvar
typVar2simTypVar x = SimTyvar $ cleanup ("'aa_" ++ showPpr x)

classId2sigId :: HS.ClassId -> SigId
classId2sigId x = SigId $ cleanup (showPpr x ++ "_SIG")

superId :: HS.ClassConstraint -> ValId
superId (HS.ClassConstraint id _) = 
    ValId $ cleanup (showPpr id ++ "_SUPER__")

superId' :: HS.ClassId -> ValId
superId' id = 
    ValId $ cleanup (showPpr id ++ "_SUPER__")

typeId = TypId "t__"