-- 
-- Copyright (C) 2005 Stefan Wehr - http://www.stefanwehr.de
--
-- This program is free software; you can redistribute it and/or
-- modify it under the terms of the GNU General Public License as
-- published by the Free Software Foundation; either version 2 of
-- the License, or (at your option) any later version.
-- 
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
-- General Public License for more details.
-- 
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
-- 02111-1307, USA.
-- 

-- The code of this module is derived from Hatchet 
-- (http://www.cs.mu.oz.au/~bjpop/hatchet.html)

module Phrac.DependAnalysis where

import Data.Graph

getBindGroups :: Ord name =>
                 [node]          -- List of nodes
              -> (node -> name)  -- Function to convert nodes to a unique name
              -> (node -> [name])-- Function to return dependencies of this node
              -> [[node]]        -- Bindgroups
getBindGroups ns getName getDeps =
    map flattenSCC (stronglyConnComp graph)
    where graph = [ (node, getName node, getDeps node) | node <- ns ]

